using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace Forum
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private MyGridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Forum.Form1.MyGridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.FreezePainting = false;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(24, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(360, 240);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 310);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();

			DataSet ds = new DataSet();
			ds.Tables.AddRange(new DataTable[]{parentTable, childTable}); 
			DataRelation parentToChild = new DataRelation("ParentToChild", parentTable.Columns["parentID"], childTable.Columns["ParentID"]);
			ds.Relations.Add(parentToChild);

			this.gridDataBoundGrid1.DataSource = ds;
			this.gridDataBoundGrid1.DataMember = parentTable.TableName; 
			level0 = this.gridDataBoundGrid1.Binder.RootHierarchyLevel;
			level1  = this.gridDataBoundGrid1.Binder.AddRelation("ParentToChild");

			level0.LayoutColumns(new string[] { "parentID", "ParentName", "ParentDec"});
			stringArray = new string[] { "childID", "Name","ParentID"};
			level1.LayoutColumns(stringArray);

			this.gridDataBoundGrid1.Model.ColsMoving += new GridRangeMovingEventHandler(Model_ColsMoving);
		} 

		string[] stringArray;

		GridHierarchyLevel level0,level1;
		# region DataTable
		private int numberParentRows = 5;
		private int numberChildRows = 20;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable"); 

			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec")); 
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dt.Rows.Add(dr);
			} 
			return dt;
		} 
		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable"); 
			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P

			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dt.Rows.Add(dr);
			}

			return dt;
		} 

		# endregion

		# region tracing column moves
		
		private void Model_ColsMoving(object sender, GridRangeMovingEventArgs e)
		{
			this.gridDataBoundGrid1.FreezePainting = true;
			this.gridDataBoundGrid1.BeginUpdate();
			SaveAndCollapse();
			ChangeOrder(e.From, e.Target);
			Restore();
			this.gridDataBoundGrid1.EndUpdate();
			this.gridDataBoundGrid1.FreezePainting = false;
		}

		# endregion
		
		private void ChangeOrder( int moveFrom, int moveTo)//string[] array,
		{
			try
			{
				ArrayList al = WrapToArrayList(stringArray);
				string isolate = al[moveFrom-2].ToString();
				al.Remove((object)isolate);
				al.Insert(moveTo-2,isolate);
				stringArray = WrapToStingArray(al);
				level1.LayoutColumns(stringArray);
			}
			catch 
			{
			}
		}

		private ArrayList WrapToArrayList(string[] sa)
		{
			ArrayList al = new ArrayList();
			for(int i=0; i<sa.Length; i++)
				al.Add(sa[i]);
			return al;
		}
		private string[] WrapToStingArray(ArrayList al)
		{
			string[] sa = new string[al.Count];
			for(int i=0; i<al.Count; i++)
				sa[i] = al[i].ToString();
			return sa;
		}

		# region Before Collapse
		private ArrayList saveExpanded = new ArrayList();

		private void SaveAndCollapse()
		{
			saveExpanded.Clear();
           
			for(int i = gridDataBoundGrid1.Model.Rows.HeaderCount + 1; i < gridDataBoundGrid1.Model.RowCount - 1; ++i)
			{
				GridBoundRecordState rs = gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(i);
				if(gridDataBoundGrid1.IsExpandedAtRowIndex(i))
				{
					saveExpanded.Add(new SavedExpandedState(rs.Table[rs.Position] as DataRowView));
				}
			}
			gridDataBoundGrid1.CollapseAll();
		}

		private void Restore()
		{
			int i;
			i = gridDataBoundGrid1.Model.RowCount - 1;
			while( i > gridDataBoundGrid1.Model.Rows.HeaderCount)
			{
				GridBoundRecordState rs = gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(i);
				if (saveExpanded.IndexOf(new SavedExpandedState(rs.Table[rs.Position] as DataRowView)) > -1)
					ExpandRowAndItsChildrenAtRow(i);

                
				i -= 1;
			}
		}

		private int ExpandRowAndItsChildrenAtRow(int row)
		{
			int i;
																						   
			int rowsUsed = 0;
			GridBoundRecordState rs = gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(row);
         
			if(saveExpanded.IndexOf(new SavedExpandedState(rs.Table[rs.Position] as DataRowView)) > -1)
			{
				gridDataBoundGrid1.ExpandAtRowIndex(row);
			
				i = row + 1;
				GridBoundRecordState rs1 = gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(i);

				while( i < gridDataBoundGrid1.Model.RowCount && rs1.LevelIndex > rs.LevelIndex)
				{    
					rowsUsed += 1 + ExpandRowAndItsChildrenAtRow(row + rowsUsed + 1);
					i = row + rowsUsed + 1;
					if( i < gridDataBoundGrid1.Model.RowCount)
						rs1 = gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(i);
				}
			}
			 
			return rowsUsed;
		}
	#endregion

		# region SavedExpandedState

		public class SavedExpandedState
		{
			DataRowView drv;
			public SavedExpandedState(DataRowView drv)
			{
				this.drv = drv;
			}
	 
			public DataRowView dRowView 
			{
				get{return drv;}
				set{drv = value;}
			}

			public override int GetHashCode()
			{
				return base.GetHashCode ();
			}

			public override bool Equals(object obj)
			{
				SavedExpandedState o = obj as SavedExpandedState;
				int count = o.drv.Row.Table.Columns.Count;
				bool b = (count == drv.Row.Table.Columns.Count);
				int i = 0;

				while(b && i < count)
				{
					b = b & (o.drv.Row[i] == drv.Row[i]);
					i += 1;
				}
				return b;
			}

		}

		# endregion

		// Class to be used if flickering is to be avoided on sorting..
		public class MyGridDataBoundGrid : GridDataBoundGrid
		{
			#region "Code to Freeze System Painting for this grid"

			private const int WM_SETREDRAW = 11;
			private int paintFrozen;

			[DllImport("User32.dll", CharSet=CharSet.Auto)]
			public static extern bool SendMessage(IntPtr hWnd, int Msg, int wParam, int lParam);



			public bool FreezePainting 
			{
				get {return (paintFrozen > 0); }
				set 
				{
					if (value && this.IsHandleCreated && this.Visible)
					{
						if (0 == paintFrozen)
						{
							paintFrozen = paintFrozen + 1;
							SendMessage(Handle, WM_SETREDRAW, 0, 0);
						}
						else
							paintFrozen = paintFrozen + 1;

					}

					if (!value)
					{
						if (paintFrozen == 0) 
							return;

						paintFrozen = paintFrozen - 1;
						if (0 == paintFrozen)
						{
							SendMessage(Handle, WM_SETREDRAW, 1, 0);
							this.Invalidate(true);
						}

					}

				}
			}
			#endregion  
		}


	}
}
